package com.gbaldu.fractal.model;

import java.util.concurrent.ConcurrentLinkedQueue;
import java.util.concurrent.atomic.AtomicLong;

import com.gbaldu.fractal.tool.Complex;

import javafx.beans.property.DoubleProperty;
import javafx.beans.property.IntegerProperty;
import javafx.beans.property.ObjectProperty;
import javafx.beans.property.SimpleDoubleProperty;
import javafx.beans.property.SimpleIntegerProperty;
import javafx.beans.property.SimpleObjectProperty;
import javafx.beans.property.SimpleStringProperty;
import javafx.beans.property.StringProperty;
import javafx.scene.image.WritableImage;
import javafx.scene.paint.Color;

/**
 * The FractalModel class serves as an abstract representation of most fractals.
 * It encapsulates data used to represent the fractal, and generation statistics.
 */
public class FractalModel
{
    /**
     * The maximum number of iterations; due to double limitations, going further does not result in a smoother image
     */
    public final static double MAX_ITERATIONS = 100000;
    /**
     * How much one zoom actually zooms
     */
    public final double scaleIncrement = 1.1;
    /**
     * The number of iterations used to compute the corresponding member of results
     */
    public int[][] iterations;
    /**
     * The results of the computation
     */
    public Complex[][] results;
    /**
     * The image which will be generated by the controller
     */
    public WritableImage writableImage;
    /**
     * The column data that was already calculated; This container is used for its thread safety
     */
    public ConcurrentLinkedQueue<Integer> calculatedColumns = new ConcurrentLinkedQueue<>();
    /**
     * The colors used to draw the fractal
     */
    public Color[] colors;
    /**
     * How many lines were already calculated
     */
    public int nbLinesCalculated;
    /**
     * Whether the application was already zooming in on the model or not
     */
    public boolean isZooming = false;
    /**
     * Generation stats; Time of the beginning of the render task
     */
    public long renderStartTime;
    /**
     * Generation stats; Duration of the calculation
     */
    public AtomicLong calcTime;
    /**
     * Generation stats; Duration of the drawing task
     */
    public long drawTime;
    /**
     * Generation stats; Total duration
     */
    public long totalRenderTime;
    /**
     * Generation stats;
     */
    public StringProperty generationStatistics = new SimpleStringProperty("");
    /**
     * Whether the program display generation stats and thread start times in the console
     */
    public Boolean verbose = false;
    /**
     * The width of the image
     */
    private int width;
    /**
     * The height of the image
     */
    private int height;
    /**
     * Half the width
     */
    private int halfWidth;
    /**
     * Half the height
     */
    private int halfHeight;
    /**
     * A FractalType property giving the type of the fractal
     */
    private ObjectProperty<FractalType> fractalType = new SimpleObjectProperty<>();
    /**
     * A Double property for the number of iterations in the calculus
     */
    private ObjectProperty<Double> maxIterations = new SimpleObjectProperty<>(5.);
    /**
     * An Integer property for the color scheme
     */
    private IntegerProperty colorOffset = new SimpleIntegerProperty(15);
    /**
     * A Double property for the scale(zoom) factor
     */
    private ObjectProperty<Double> scale = new SimpleObjectProperty<>(1.);
    /**
     * A Double property for the position of the center along the X axis
     */
    private ObjectProperty<Double> centerX = new SimpleObjectProperty<>(0.);
    /**
     * A Double property for the position of the center along the Y axis
     */
    private ObjectProperty<Double> centerY = new SimpleObjectProperty<>(0.);
    /**
     * A Double property which represents the completion percentage of the computation
     */
    private DoubleProperty generationStatus = new SimpleDoubleProperty(0.);

    /**
     * Default constructor. Cannot be used
     */
    protected FractalModel()
    {
    }

    /**
     * Constructor that must be used when making a new instance of FractalModel.
     *
     * @param type The type of the fractal that will be represented by this model.
     */
    public FractalModel(FractalType type)
    {
        this.setFractalType(type);
    }

    /**
     * Getter for the scale property
     * @return The scale factor
     */
    public double getScale()
    {
        return scale.get();
    }

    /**
     * Setter for the scale property
     * @param scale The value to use as new scale factor
     */
    public void setScale(double scale)
    {
        this.scale.set(scale);
    }

    /**
     * Getter for the scale property itself
     * @return The scale property
     */
    public ObjectProperty<Double> scaleProperty()
    {
        return scale;
    }

    /**
     * Getter for the maxIterations property
     * @return The max iterations in the calculus
     */
    public Double getMaxIterations()
    {
        return maxIterations.get();
    }

    /**
     * Setter for the maxIterations property
     * @param maxIterations The value to use as new max iterations value
     */
    public void setMaxIterations(Double maxIterations)
    {
        this.maxIterations.set(maxIterations);
    }

    /**
     * Getter for the maxIterations property itself
     * @return The maxIterations property
     */
    public ObjectProperty<Double> maxIterationsProperty()
    {
        return maxIterations;
    }

    /**
     * Getter for the generationStatus property
     * @return The progress of the current generation operation
     */
    public Double getGenerationStatus()
    {
        return generationStatus.get();
    }

    /**
     * Setter for the generationStatus property
     * @param generationStatus The value to use as new generation progress value
     */
    public void setGenerationStatus(Double generationStatus)
    {
        this.generationStatus.set(generationStatus);
    }

    /**
     * Getter for the generationStatus property itself
     * @return The generationStatus property
     */
    public DoubleProperty generationStatusProperty()
    {
        return generationStatus;
    }

    /**
     * Getter for the fractalType property
     * @return The FractalType corresponding to the represented fractal
     */
    public FractalType getFractalType()
    {
        return fractalType.get();
    }

    /**
     * Setter for the fractalType property
     * @param fractalType The value to use as new fractal type
     */
    public void setFractalType(FractalType fractalType)
    {
        this.fractalType.set(fractalType);
    }

    /**
     * Getter for the fractalType property itself
     * @return The fractalType property
     */
    public ObjectProperty<FractalType> fractalTypeProperty()
    {
        return fractalType;
    }

    /**
     * Getter for the generationStatistics property
     * @return A string containing render times and draw times
     */
    public String getGenerationStatistics()
    {
        return generationStatistics.get();
    }

    /**
     * Setter for the generationStatistics property
     * @param generationStatistics The value to use as new statistics
     */
    public void setGenerationStatistics(String generationStatistics)
    {
        this.generationStatistics.set(generationStatistics);
    }

    /**
     * Getter for the generationStatistics property itself
     * @return The generationStatistics property
     */
    public StringProperty generationStatisticsProperty()
    {
        return generationStatistics;
    }

    /**
     * Getter for the position of the image along the X axis
     * @return The Double value of the X position
     */
    public Double getCenterX()
    {
        return centerX.get();
    }

    /**
     * Setter for the position of the image along the X axis
     * @param centerX The new value to use as X position
     */
    public void setCenterX(Double centerX)
    {
        this.centerX.set(centerX);
    }

    /**
     * Getter for the centerX property itself
     * @return The centerX property
     */
    public ObjectProperty<Double> centerXProperty()
    {
        return centerX;
    }

    /**
     * Getter for the position of the image along the Y axis
     * @return The Double value of the Y position
     */
    public Double getCenterY()
    {
        return centerY.get();
    }

    /**
     * Setter for the position of the image along the Y axis
     * @param centerY The new value to use as Y position
     */
    public void setCenterY(Double centerY)
    {
        this.centerY.set(centerY);
    }

    /**
     * Getter for the centerY property itself
     * @return The centerY property
     */
    public ObjectProperty<Double> centerYProperty()
    {
        return centerY;
    }

    /**
     * Setter for both X and Y positions
     * @param center A complex which a value is X, and imaginary is Y
     */
    public void setCenter(Complex center)
    {
        this.centerX.set(center.real);
        this.centerY.set(center.imaginary);
    }

    /**
     * Setter for both X and Y positions
     * @param a The position along the X axis
     * @param b The position along the Y axis
     */
    public void setCenter(Double a, Double b)
    {
        if (a != null)
            this.centerX.set(a);
        if (b != null)
            this.centerY.set(b);
    }

    /**
     * Permits moving to a point by adding the parameters and the old coordinates
     * @param a The offset along the X axis
     * @param b The offset along the Y axis
     */
    public void addToCenter(Double a, Double b) {
        if (a != null)
            this.centerX.set(a + this.centerX.get());
        if (b != null)
            this.centerY.set(b + this.centerY.get());
    }

    /**
     * Getter for the colorOffset property
     * @return The color offset as an integer
     */
    public int getColorOffset()
    {
        return colorOffset.get();
    }

    /**
     * Setter for the colorOffset property
     * @param colorOffset The new value to use as color offset
     */
    public void setColorOffset(int colorOffset)
    {
        this.colorOffset.set(colorOffset);
    }

    /**
     * Getter for the colorOffset property itself
     * @return The colorOffset property itself
     */
    public IntegerProperty colorOffsetProperty()
    {
        return colorOffset;
    }

    /**
     * Getter for the width of the image
     * @return The width of the image
     */
    public int getWidth()
    {
        return width;
    }

    /**
     * Getter for the height of the image
     * @return The height of the image
     */
    public int getHeight()
    {
        return height;
    }

    /**
     * Getter for the half of the width
     * @return Half the width
     */
    public int getHalfWidth()
    {
        return halfWidth;
    }

    /**
     * Getter for the half of the height
     * @return Half the height
     */
    public int getHalfHeight()
    {
        return halfHeight;
    }

    /**
     * Setter for the size of the image. Also sets halfWidth and halfHeight.
     * @param width The image's width
     * @param height The image's height
     */
    public void setSize(int width, int height)
    {
        this.width = width;
        this.height = height;

        this.halfWidth = width / 2;
        this.halfHeight = height / 2;
    }
}